package infomat.algorithms.description;

import infomat.vectorspace.*;
import infomat.vectorspace.similarity.*;
import infomat.vectorspace.ivector.*;

import mro.util.*;
import mro.util.properties.*;

import java.util.*;


/**
 * Constructs ILabels for IObjectGroups, the first in the centroid.
 *
 * @version          090104
 * @author           Magnus Rosell
 *
 */
public class CentroidDescriber extends Describer{

    public CentroidDescriber(){
	this.properties = getDefaultProperties();
    }

    public CentroidDescriber(mro.util.properties.Properties properties){
	this.properties = properties;
    }

    public mro.util.properties.Properties getDefaultProperties(){

	mro.util.properties.Properties properties = new mro.util.properties.Properties("Centroid Describer Properties", CurrentClassGetter.getClassName());
		
	    /*
	try{

	    Property p = new Property("Number of objects in labels", 10, "The number of objects in each label");
	    properties.addProperty(p);

	}catch(PropertyNameConflictException pnce){
	    // Won't happen here
	}
	    */

	return properties;
    }


    public Object getPropertyValue(String name){
	return properties.getPropertyValue(name);
    }

    public void setProperty(String name, Object value) 
	throws PropertyNotFoundException{
	properties.setProperty(name, value);
    }

    public mro.util.properties.Properties getProperties(){
	return properties;
    }

    public void setProperties(mro.util.properties.Properties properties){
	this.properties=properties;
    }



    /*********************************/



    public IVector<IVectorIndex> describeGroup(IObjectGroup iog, 
					  SparseISimilarity similarity){

	return similarity.getGroupRepresentation(iog);
    }

    public HashMap<IObjectGroup, IVector<IVectorIndex>> describeGrouping(IObjectGrouping ioging, SparseISimilarity similarity){

	/*
    public HashMap<IObjectGroup, IVector<IObject>>
	describeGrouping(IObjectGrouping ioging, 
			 SparseISimilarity similarity){
	*/

	HashMap<IObjectGroup, IVector<IVectorIndex>> groupDescriptionMap = 
	    new HashMap<IObjectGroup, IVector<IVectorIndex>>();

	Vector<IObjectGroup> groups = ioging.getGroups();
	for(int i=0; i<groups.size(); i++){
	    IObjectGroup iog = groups.elementAt(i);
	    IVector<IVectorIndex> ivec = describeGroup(iog, similarity);
	    
	    //	    System.out.println(iog.getString()+", description size: "+ivec.size());

	    groupDescriptionMap.put(iog, ivec);
	}

	return groupDescriptionMap;
    }

    /*********************************/
   
    public String getName(){
	return "Centroid Describer";
    }



}

