package infomat.algorithms.description;

import infomat.vectorspace.*;
import infomat.vectorspace.similarity.*;
import infomat.vectorspace.ivector.*;

import mro.util.*;
import mro.util.properties.*;

import java.util.*;


/**
 * Constructs an IObjectGrouping from a description.
 *
 * @version          090104
 * @author           Magnus Rosell
 *
 */
public class DescriptionGrouper{

    public static int descriptionGrouperClusteringNumber = 1;

    public IObjectGrouping groupingFromDescription(IObjectGrouping oldGrouping, HashMap<IObjectGroup, IVector<IVectorIndex>> groupingDescription){
	IObjectGrouping grouping = new IObjectGrouping("Grouping from Description for ("+oldGrouping.getString()+") "+descriptionGrouperClusteringNumber);
	descriptionGrouperClusteringNumber++;

	HashMap<IObjectGroup, IObjectGroup> oldGroupNewGroupMap = 
	    new HashMap<IObjectGroup, IObjectGroup>();

	IVector<IVectorIndex> all = new IVector<IVectorIndex>();
	//	Iterator<Map.Entry<IObjectGroup, IVector<IVectorIndex>>> it = groupingDescription.entrySet().iterator();
	//	while(it.hasNext()){
	Vector<IObjectGroup> oldGroups = oldGrouping.getGroups();
	for(int i=0; i<oldGroups.size(); i++){
	    IObjectGroup oldG = oldGroups.get(i);
	    //	    Map.Entry<IObjectGroup, IVector<IVectorIndex>> entry = it.next();
	    //	    IObjectGroup oldG = entry.getKey();
	    IObjectGroup newG = new IObjectGroup("Group From Description for "+oldG.getString());
	    grouping.add(newG);
	    oldGroupNewGroupMap.put(oldG, newG);

	    IVector<IVectorIndex> ivec = groupingDescription.get(oldG);
	    //	    IVector<IVectorIndex> ivec = entry.getValue();
	    //	    System.out.println("Delvektor: "+ivec.size());

	    all.add(ivec);
	}
	//	System.out.println("Alla: "+all.size());
	//	System.out.println("------------------");

	/*
	it = groupingDescription.entrySet().iterator();
	Map.Entry<IObjectGroup, IVector<IObject>> entry = it.next();
	IVector<IObject> ivec = entry.getValue();
	IVector<IObject> all = new IVector<IObject>(ivec);
	while(it.hasNext()){
	    entry = it.next();
	    ivec = entry.getValue();
	    all.add(ivec);
	}
	*/

	Vector<IVectorIndex> allVec = all.getUnorderedVector();
	for(int i=0; i<allVec.size(); i++){
	    IVectorIndex ii = allVec.get(i);
	    Best b = findBestGroup(ii, groupingDescription);

	    //	    System.out.print(ii.getString()+", best: "+b.group.getString());

	    IObjectGroup newG = oldGroupNewGroupMap.get(b.group);
	    if(b.value!=null){
		//		System.out.print(", new:"+newG.getString());
		newG.add((IObject) ii, b.value);
	    }
	    //	    System.out.println();
	}

	grouping.sort();

	return grouping;
    }

    private Best findBestGroup(IVectorIndex ii, HashMap<IObjectGroup, IVector<IVectorIndex>> groupingDescription){

	Iterator<Map.Entry<IObjectGroup, IVector<IVectorIndex>>> it = groupingDescription.entrySet().iterator();
	Map.Entry<IObjectGroup, IVector<IVectorIndex>> entry = it.next();
	IObjectGroup oldG = entry.getKey();
	IVector<IVectorIndex> groupDescription = entry.getValue();
	Float value = groupDescription.getValue(ii);
	Best b = new Best(oldG, value);

	while(it.hasNext()){
	    entry = it.next();
	    groupDescription = entry.getValue();
	    value = groupDescription.getValue(ii);
	    if(value!=null){
		if(b.value==null || value>b.value)
		    b = new Best(entry.getKey(), value);
	    }
	}
	return b;
    }

    private class Best{
	public IObjectGroup group;
	public Float value;

	public Best(IObjectGroup group, Float value){
	    this.group=group;
	    this.value=value;
	}
    }


}

