package infomat.algorithms.description;

import infomat.vectorspace.*;
import infomat.vectorspace.similarity.*;
import infomat.vectorspace.ivector.*;

import mro.util.*;
import mro.util.properties.*;

import java.util.*;


/**
 * Constructs ILabels for IObjectGroups.
 *
 * @version          090812
 * @author           Magnus Rosell
 *
 */
public class WeightAndPredictiveDescriber extends Describer{

    public WeightAndPredictiveDescriber(){
	this.properties = getDefaultProperties();
    }

    public WeightAndPredictiveDescriber(mro.util.properties.Properties properties){
	this.properties = properties;
    }

    public mro.util.properties.Properties getDefaultProperties(){

	mro.util.properties.Properties properties = new mro.util.properties.Properties("Weight And Predictive Describer Properties", CurrentClassGetter.getClassName());
		
	    /*
	try{

	    Property p = new Property("Number of objects in labels", 10, "The number of objects in each label");
	    properties.addProperty(p);

	}catch(PropertyNameConflictException pnce){
	    // Won't happen here
	}
	    */

	return properties;
    }


    public Object getPropertyValue(String name){
	return properties.getPropertyValue(name);
    }

    public void setProperty(String name, Object value) 
	throws PropertyNotFoundException{
	properties.setProperty(name, value);
    }

    public mro.util.properties.Properties getProperties(){
	return properties;
    }

    public void setProperties(mro.util.properties.Properties properties){
	this.properties=properties;
    }



    /*********************************/


    /*
    private IVector<IVectorIndex> describeGroup(IObjectGroup iog, 
					  SparseISimilarity similarity){

	return similarity.getGroupRepresentation(iog);
    }
    */

    public HashMap<IObjectGroup, IVector<IVectorIndex>> describeGrouping(IObjectGrouping ioging, SparseISimilarity similarity){

	/*
	if(!(similarity instanceof SparseDotSimilarity))
	    return null;
	
	SparseDotSimilarity sim = (SparseDotSimilarity) similarity;
	IMatrix matrix = sim.getIMatrix();
	boolean row = sim.getIMatrixDimension();
	*/


	IVector<IVectorIndex> groupingWeights = 
	    similarity.getGroupRepresentation(ioging); 

	HashMap<IObjectGroup, IVector<IVectorIndex>> groupDescriptionMap = 
	    new HashMap<IObjectGroup, IVector<IVectorIndex>>();

	Vector<IObjectGroup> groups = ioging.getGroups();
	for(int i=0; i<groups.size(); i++){
	    IObjectGroup iog = groups.elementAt(i);

	    IVector<IVectorIndex> groupWeights = 
		similarity.getGroupRepresentation(iog); 

	    Vector<IVectorIndex> vec = groupWeights.getUnorderedVector();
	    for(int j=0; j<vec.size(); j++){
		IVectorIndex ii = vec.get(j);
		Float groupW = groupWeights.getValue(ii);
		Float groupingW = groupingWeights.getValue(ii);
		if(groupW!=null && groupingW!=null)
		    groupWeights.put(ii, groupW*groupW/groupingW);
		else
		    groupWeights.put(ii, 0.0f);
	    }
	    
	    groupDescriptionMap.put(iog, groupWeights);
	}

	return groupDescriptionMap;
    }


    /*********************************/
   
    public String getName(){
	return "Weight And Predictive Describer";
    }



}

