package infomat.vectorspace.ri;

import infomat.vectorspace.*;
import infomat.vectorspace.similarity.*;

import mro.util.*;
import mro.util.properties.*;

import java.util.HashMap;
import java.util.Vector;

/**
 *
 * @version          091008
 * @author           Magnus Rosell
 */
public class RIDotSimilarity extends DenseISimilarity{


    public mro.util.properties.Properties getDefaultProperties(){

	mro.util.properties.Properties properties = 
	    new mro.util.properties.Properties("RI Dot Product Similarity Properties", CurrentClassGetter.getClassName());
		
	    /*	    
	try{

	    Property p = new Property("Normalize", false, "Wether normalization is used. This can also be done through the Weighter.");
	    PropertyValueDescription pvd = 
		new PropertyValueDescription(true, "Do it.");
	    p.addValueDescription(pvd);
	    pvd = new PropertyValueDescription(false, "Do not do it.");
	    p.addValueDescription(pvd);
	    properties.addProperty(p);

	}catch(PropertyNameConflictException pnce){
	    // Won't happen here
	}
	    */


	return properties;
    }


    public Vector getPropertyVector(){
    	return properties.getPropertyVector();
    }
    

    public Object getPropertyValue(String name){
    	return properties.getPropertyValue(name);
    }

    public void setProperty(String name, Object value) throws PropertyNotFoundException{
	/*
    	properties.setProperty(name, value);
	if(name.compareTo("Normalize")==0)
	    normalize = (Boolean) getPropertyValue("Normalize");
	*/
    }

    public mro.util.properties.Properties getProperties(){
    	return properties;
    }
    public void setProperties(mro.util.properties.Properties properties){
    	this.properties=properties;
    }

    


    RI ri;

    public RIDotSimilarity(RI ri){
	super();
	this.ri=ri;
    }

    public float sim(float[] repr1, float[] repr2){
	float res = 0;
	for(int i=0; i<repr1.length; i++){
	    res += repr1[i]*repr2[i];
	}
	return res;
    }

    public float[] getRepresentation(IObject io){

	return new float[1];
    }

    public float[] getGroupRepresentation(IObjectGroup iog){

	return new float[1];
    }

    public float[] getUnnormalizedGroupRepresentation(IObjectGroup iog){

	return new float[1];
    }

    public String getName(){
	return "RI Dot Similarity";
    }

    public float sim(IObject io1, IObject io2){
	return 0.0f;
    }


    public float sim(IObject io, IObjectGroup iog){
	return 0.0f;
    }

    public float sim(IObjectGroup iog1, IObjectGroup iog2){
	return 0.0f;
    }

}
