package infomat.vectorspace.ri;

import infomat.vectorspace.*;

import java.io.*;
import java.util.*;



/**
 *
 * @version          091005
 * @author           Magnus Rosell
 */
public class RISparseVector{

    private int n;
    private HashMap<Integer, Float> indexValueMap = 
	new HashMap<Integer, Float>();

    //    private ArrayList<RIEntry> values = new ArrayList<RIEntry>();


    public RISparseVector(int n, int nr){
	this.n=n;
	for(int i=0; i<nr; i++){
	    int index = getNextIndex();
	    float value = 1;
	    indexValueMap.put(index, value);
	    //	    values.add(new RIEntry(index, value));

		       
	    index = getNextIndex();
	    value = -1;
	    indexValueMap.put(index, value);
	    //	    values.add(new RIEntry(index, value));
	}
    }
    
    private int getNextIndex(){
	int index = 0;
	boolean success = false;
	while(!success){
	    index = (int) (Math.random()*n);
	    
	    success = false;
	    Float f = indexValueMap.get(index);
	    if(f==null)
		success = true;
	    /*
	    success = true;
	    for(int i=0; i<values.size(); i++){
		if(values.get(i).index==index){
		    success=false;
		    break;
		}
	    }
	    */
	}

	return index;
    }
	

    public boolean equals(RISparseVector risv){
	if(risv.n!=n)
	    return false;
	
	Iterator<Map.Entry<Integer, Float>> it = risv.indexValueMap.entrySet().iterator();
	while(it.hasNext()){
	    Map.Entry<Integer, Float> entry = it.next();
	    Float f = indexValueMap.get(entry.getKey());
	    if(f==null || f!=entry.getValue())
		return false;
	}

	return true;

	/*
	boolean ret = true;
	for(int i=0; i<risv.values(); i++){
	    RIEntry otherEntry = risv.values.get(i);
	    
	}
	*/
    }

    public void addToArray(float[] array){
	Iterator<Map.Entry<Integer, Float>> it = indexValueMap.entrySet().iterator();
	while(it.hasNext()){
	    Map.Entry<Integer, Float> entry = it.next();
	    array[entry.getKey()] += entry.getValue();
	}

	/*
	for(int i=0; i<values.size(); i++){
	    RIEntry rie = values.get(i);
	    array[rie.index] += rie.value;
	}
	*/
    }


    public void addWeightedToArray(float[] array, float weight){
	Iterator<Map.Entry<Integer, Float>> it = indexValueMap.entrySet().iterator();
	while(it.hasNext()){
	    Map.Entry<Integer, Float> entry = it.next();
	    array[entry.getKey()] += weight * entry.getValue();
	}
	/*
	for(int i=0; i<values.size(); i++){
	    RIEntry rie = values.get(i);
	    array[rie.index] += weight * rie.value;
	}
	*/
    }

    public String toString(){
	String ret = "";
	Iterator<Map.Entry<Integer, Float>> it = indexValueMap.entrySet().iterator();
	while(it.hasNext()){
	    Map.Entry<Integer, Float> entry = it.next();
	    //	    System.out.println(entry.getKey()+": "+entry.getValue());
	    ret += entry.getKey()+": "+entry.getValue()+"\n";;
	}	
	//	System.out.println();
	ret += "\n";
	return ret;
    }



    private class RIEntry{
	int index;
	float value;

	public RIEntry(int index, float value){
	    this.index=index;
	    this.value=value;
	}

	public boolean equals(RIEntry rie){
	    if(rie.index!=index)
		return false;
	    if(rie.value!=value)
		return false;
	    return true;
	}
    }


}

