package infomat.view.info;

import infomat.view.*;
import infomat.view.grouping.settings.*;
import infomat.view.picture.*;
import infomat.vectorspace.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;

public class MousePointerInfoPanel extends JPanel{

    /*
    public static Dimension ALGORITHMFRAME_PREFERRED_SIZE = 
	new Dimension(300, 800);
    */

    public static int MONITORSIZEMAXIMUM = 10000;
    public static int MATRIXSIZEMAXIMUM = 1000000;

    //    private InfomatModel model;
    private PixelPanel pixelPanel;
    private RowColumnPanel rowColumnPanel;
    private boolean show = true;

    public MousePointerInfoPanel(){ //InfomatModel model){
	//	this.model=model;
		
	setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
	//	setLayout(new FlowLayout(FlowLayout.LEFT));

	//	setBorder(LineBorder.createBlackLineBorder());
	//	setBorder(new TitledBorder(""));
		

	pixelPanel = new PixelPanel(); 
	rowColumnPanel = new RowColumnPanel();

	Dimension size = pixelPanel.getPreferredSize();
	size = new Dimension((int) size.getWidth()+50, 
			     (int) size.getHeight());
	pixelPanel.setPreferredSize(size);
	pixelPanel.setMinimumSize(size);
	pixelPanel.setMaximumSize(size);
	

		
	putAll();
	repaint();
    }

    public void putAll(){
	removeAll();

	add(pixelPanel);
	add(rowColumnPanel);

	revalidate();
	repaint();
    }

    public boolean display(){
	return show;
    }

    public void toggle(){
	show=!show;
    }

    public void paintComponent(Graphics g){
	super.paintComponent(g);
    }
	

    public void setPixel(int row, int col){
	pixelPanel.setPixel(row, col);
    }

    /*
    public void setPixel(String rowText, String colText){
	pixelPanel.setPixel(rowText, colText);
    }

    public void setRowColumn(String rowText, String colText){
	rowColumnPanel.setRowColumn(rowText, colText);
    }
    */

    public void setRowColumn(int row, String rowText, 
			     int col, String colText){
	rowColumnPanel.setRowColumn(row, rowText, col, colText);
    }

    public void setNoInfoPixel(){
	pixelPanel.setNoInfo();

    }
    
    public void setNoInfoRowColumn(){
	rowColumnPanel.setNoInfo();
    }



    private class PixelPanel extends JPanel{
	private JLabel rowLabel;
	private JLabel colLabel;
		
	private String noText ="";
	private int maxLength = 
	    (""+MousePointerInfoPanel.MONITORSIZEMAXIMUM).length();
		
	public PixelPanel(){
	    super();
	    setBorder(new TitledBorder("Picture"));

	    for(int i=0; i < maxLength; i++)
		noText = noText+" ";

	    
	    setLayout(new GridLayout(2,1));
	    //	    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));


	    /*
	    String dummyText = "Column: ";
	    for(int i=0; i < maxLength; i++)
		dummyText += "*";

	    rowLabel = new JLabel(dummyText);
	    colLabel = new JLabel(dummyText);
	    setNoInfo();
	    add(rowLabel);
	    add(colLabel);

	    //	    setPreferredSize(getSize());
	    setMinimumSize(getPreferredSize());
	    setMaximumSize(getPreferredSize());
	    */

	    removeAll();
	    rowLabel = new JLabel(noText);
	    colLabel = new JLabel(noText);
	    setNoInfo();
	    add(rowLabel);
	    add(colLabel);
	}

	public void setNoInfo(){
	    rowLabel.setText(" Row:        "+noText);
	    colLabel.setText(" Column:  "+noText);			
	    repaint();
	}
		
	public void setPixel(int row, int col){
	    String rowString = ""+row;
	    for(int i=rowString.length(); 
		i < maxLength; i++)
		rowString = " "+rowString;

	    String colString = ""+col;
	    for(int i=colString.length(); 
		i < maxLength; i++)
		colString = " "+colString;

	    rowLabel.setText(" Row:        "+rowString);
	    colLabel.setText(" Column:  "+colString);			
	    repaint();
	}
		
	public void paintComponent(Graphics g){
	    super.paintComponent(g);
	}
		
    }



    private class RowColumnPanel extends JPanel{
	private JLabel rowLabel;
	private JLabel colLabel;
		
	private String noText =" ";
	private int maxLength = 
	    (""+MousePointerInfoPanel.MATRIXSIZEMAXIMUM).length();
		
	public RowColumnPanel(){
	    super();
	    setBorder(new TitledBorder("Matrix"));
	
	    for(int i=0; i < maxLength; i++)
		noText = noText+" ";
		
	    //	    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
	    setLayout(new GridLayout(2,1));
	    rowLabel = new JLabel(noText);
	    colLabel = new JLabel(noText);
	    setNoInfo();
	    add(rowLabel);
	    add(colLabel);
	}
		
	public void setNoInfo(){
	    rowLabel.setText("Row:        "+noText);
	    colLabel.setText("Column:  "+noText);			
	    repaint();
	}
		
	public void setRowColumn(String rowText, String colText){
	    rowLabel.setText("Row:         "+rowText);
	    colLabel.setText("Column: "+colText);			
	    repaint();
	}
		
	public void setRowColumn(int row, String rowText, 
				 int col, String colText){

	    if(rowText!=null){
		String rowString = ""+row;
		for(int i=rowString.length(); 
		    i < maxLength; i++)
		    rowString = " "+rowString;
		rowLabel.setText("Row:        "+rowString+", "+rowText);
	    }else
		rowLabel.setText("Row:        "+noText);


	    if(colText!=null){
		String colString = ""+col;
		for(int i=colString.length(); 
		    i < maxLength; i++)
		    colString = " "+colString;
		colLabel.setText("Column:  "+colString+", "+colText);
	    }else
		colLabel.setText("Column:  "+noText);

	    repaint();
	}
		
	public void paintComponent(Graphics g){
	    super.paintComponent(g);
	}
		
    }






	
}
