package infomat.view.picture;

import java.util.*;
import java.awt.*;
import java.awt.image.*;
import javax.swing.border.*;

import mro.util.doublehashmap.DoubleHashMap;

import mro.util.*;
import infomat.vectorspace.*;
import infomat.view.*;
import infomat.view.menu.*;
import infomat.view.grouping.settings.GroupingColoring;

public class SparsePartPicture{ // extends JPanel{
    //    implements MouseMotionListener, MouseWheelListener, MouseListener{

    /*
      InfomatView view;
      InfomatModel model;
    */
	
    // The SparsePicture
    private SparsePicture sparsePicture;

    // The image
    private boolean toSmall=false;
    private BufferedImage image=null;
    private Dimension imageDimension;
    //	private Color backgroundColor=Color.WHITE;
    private Color borderColor=Color.BLACK;
    private MatteBorder border=null;
    private boolean largeImageRow=false; // If the image is larger than the part of the IMatrix
    private boolean largeImageCol=false; // If the image is larger than the part of the IMatrix


    private int origoX=0;
    private int origoY=0;
    private int gridX=0;
    private int gridY=0;
    private int offsetX=0;
    private int offsetY=0;

    // The pixels
    private Vector<SparsePixel> sparsePixels;
    private DoubleHashMap pixelMap;

    // Column coloring
    //Vector<SparsePixel> columnColorPixels = null;
    private HashMap<Integer, SparsePixel> columnColorMap;

    // The IMatrix
    //private IMatrix matrix;
    private int rowFrom, rowTo;
    private int colFrom, colTo;
    private IObjectGroup columnGroup;
    private IObjectGroup rowGroup;



    // For info
    private ToolbarView toolbarView=null;

    public SparsePartPicture(Dimension imageDimension,
			     int colFrom, int colTo,
			     int rowFrom, int rowTo, 
			     IObjectGroup columnGroup, IObjectGroup rowGroup){
	this.sparsePixels=new Vector<SparsePixel>();
	pixelMap = new DoubleHashMap();
	this.imageDimension=imageDimension;
	this.rowFrom=rowFrom;
	this.rowTo=rowTo;
	this.colFrom=colFrom;
	this.colTo=colTo;

	this.columnGroup = columnGroup;
	this.rowGroup = rowGroup;
		
	columnColorMap = new HashMap<Integer, SparsePixel>();
    }

	
    protected void putColumnColorPixel(SparsePixel sp){
	columnColorMap.put(sp.getX(), sp);
    }

    protected SparsePixel getColumnColorPixel(int x){
	return columnColorMap.get(x);
    }
	
    protected HashMap<Integer, SparsePixel> getColumnColorMap(){
	return columnColorMap;
    }
	
    protected void setColumnColorMap(HashMap<Integer, SparsePixel> map){
	columnColorMap=map;
    }
	
    protected Vector<SparsePixel> getColumnColorPixels(){
	return new Vector<SparsePixel>(columnColorMap.values());
    }
	
    /*
      private void makeImageCoord(){ 
      //private static int[] makeLargeImageCoordLimits(int size, int numOfSteps){
      int size = getImageHeight();
      int partNumOfRows = rowTo-rowFrom;
      int numOfSteps = 
      double step = ((double)size)/numOfSteps;
      int[] limits = new int[numOfSteps+1];
      limits[0]=0;
      for(int i=1; i<numOfSteps; i++)
      limits[i]=(int) (i * step);
      limits[numOfSteps]=size;
      return limits;
      }
    */
	
	
    protected void setSparsePicture(SparsePicture sparsePicture){
	this.sparsePicture=sparsePicture;
    }

    /*
      protected void setColumnColorPixels(Vector<SparsePixel> pixels){
      //columnColorPixels=pixels;
      }
    */

    protected void setToolbarView(ToolbarView toolbarView){
	this.toolbarView=toolbarView;
    }

    /**
     * Use with care!
     */
    protected void setOrigo(int x, int y){
	origoX=x;
	origoY=y;
    }

    /**
     * Use with care!
     */
    protected void setGridXY(int x, int y){
	gridX=x;
	gridY=y;
    }

    /**
     * Use with care!
     */
    protected void setOffsetXY(int x, int y){
	offsetX=x;
	offsetY=y;
    }

    protected void setLargeImageRow(boolean largeImageRow){
	this.largeImageRow=largeImageRow;
    }

    protected void setLargeImageCol(boolean largeImageCol){
	this.largeImageCol=largeImageCol;
    }

    /*
    private boolean getLargeImage(){
	return (largeImageRow || largeImageCol);
    }
    */

    private boolean getLargeImageRow(){
	return largeImageRow;
    }

    private boolean getLargeImageCol(){
	return largeImageCol;
    }

    protected Color getBorderColor(){
	return borderColor;
    }

	
    protected void putPixel(SparsePixel sp){
	add(sp);
    }

    protected void add(SparsePixel sp){
	sparsePixels.add(sp);


	if(!getLargeImageRow() && !getLargeImageCol())
	    pixelMap.put(sp.getX(), sp.getY(), sp);
	else{
	    if(getLargeImageRow() && getLargeImageCol()){
		for(int x=sp.getX(); x<sp.getXLast(); x++){
		    for(int y=sp.getY(); y<sp.getYLast(); y++){
			pixelMap.put(x, y, sp);
		    }
		}
	    }else if(getLargeImageRow()){
		int x=sp.getX();
		for(int y=sp.getY(); y<sp.getYLast(); y++){
		    pixelMap.put(x, y, sp);
		}
	    }else if(getLargeImageCol()){
		int y=sp.getY();
		for(int x=sp.getX(); x<sp.getXLast(); x++){
		    pixelMap.put(x, y, sp);
		}
	    }else
		pixelMap.put(sp.getX(), sp.getY(), sp);
	}



	
		/*
	pixelMap.put(sp.getX(), sp.getY(), sp);

	if(sp.getXLast()!=-1){
	    if(sp.getYLast()!=-1){
		for(int x=sp.getX(); x<sp.getXLast(); x++){
		    for(int y=sp.getY(); y<sp.getYLast(); y++){
			pixelMap.put(x, y, sp);
		    }
		}
	    }else{
		for(int x=sp.getX(); x<sp.getXLast(); x++){
		    pixelMap.put(x, sp.getY(), sp);
		}
	    }
	}else if(sp.getYLast()!=-1){
	    for(int y=sp.getY(); y<sp.getYLast(); y++){
		pixelMap.put(sp.getX(), y, sp);
	    }
	}
		*/
    }


    protected void makeAverageColumnColor(){
	Iterator pixelIterator = columnColorMap.values().iterator();
	while(pixelIterator.hasNext()){
	    SparsePixel sp = (SparsePixel) pixelIterator.next();
	    sp.makeAverageColor();
	}
    }
	
	
	
    /**
     * Adds a new SparsePixel to the picture. If there is a SparsePixel
     * at its cooridinates the new SparsePixel is accumulated to it.
     * @param sp A SparsePixel.
     */
    /*
      protected void add(SparsePixel sp){
      SparsePixel existingSP = (SparsePixel)
      pixelMap.get(sp.getX(), sp.getY());
      if(existingSP==null)
      pixelMap.put(sp.getX(), sp.getY(), sp);
      else
      existingSP.accumulate(sp);
      }
    */

    /*
      protected void addInWolePictureCoordinates(SparsePixel sp){
		
		
      }
    */
	
    /*
      protected void setColumnLines(Vector<BackgroundLine> lines){
      this.columnLines=lines;
      }
    */

    protected SparsePixel getPixel(int x, int y){
	//	    System.out.println("size: "+pixelMap.size());
	return (SparsePixel) pixelMap.get(x,y);
    }

    protected int getRowFrom(){
	return rowFrom;
    }

    protected int getRowTo(){
	return rowTo;
    }

    protected int getColFrom(){
	return colFrom;
    }

    protected int getColTo(){
	return colTo;
    }

    protected IObjectGroup getRowGroup(){
	return sparsePicture.getRowGroup();
    }

    protected IObjectGroup getColumnGroup(){
	return sparsePicture.getColumnGroup();
    }

	

    protected IObject getLastRowIObject(int y){
	double nowY = y;
	double imY = image.getHeight()-SparsePicture.getGridSize(); //-getBorderSize();
	if(nowY>imY || nowY<0)
	    return null;

	double yStep = ((double)image.getHeight())/(rowTo-rowFrom);
	int mY = rowFrom;
	if(largeImageRow){
	    mY = rowFrom + (int) ((nowY+yStep)/yStep) - 1;
	}else{
	    mY = rowFrom + (int) ((nowY+1)/yStep);
	    if(mY>rowTo-1)
		mY=rowTo-1;
	}

	return getRowGroup().getIObjectAt(mY);
    }

    protected IObject getLastColumnIObject(int x){
	double nowX = x;
	int imX = image.getWidth()-SparsePicture.getGridSize();
	if(nowX>imX || nowX<0)
	    return null;

	double xStep = ((double)image.getWidth())/(colTo-colFrom);
	int mX = colFrom;
	if(largeImageCol){
	    mX = colFrom + (int) ((nowX+xStep)/xStep) - 1;
	}else{
	    mX = colFrom + (int) ((nowX+1)/xStep);
	    if(mX>colTo-1)
		mX=colTo-1;
	}
	return getColumnGroup().getIObjectAt(mX);
    }




    protected IObject getClosestRowIObject(int y){
	double nowY = y;
	double imY = image.getHeight()-SparsePicture.getGridSize(); //-getBorderSize();
	if(nowY>imY || nowY<0)
	    return null;

	double yStep = ((double)image.getHeight())/(rowTo-rowFrom);
	int mY = rowFrom;
	if(largeImageRow){
	    mY = rowFrom + (int) (nowY/yStep);
	}else{
	    mY = rowFrom + (int) (nowY/yStep) + 1;
	    if(nowY==0)
		mY = rowFrom + (int) (nowY/yStep);
	}

	return getRowGroup().getIObjectAt(mY);
    }



    protected IObject getClosestColumnIObject(int x){
	double nowX = x;
	int imX = image.getWidth()-SparsePicture.getGridSize();
	if(nowX>imX || nowX<0)
	    return null;

	double xStep = ((double)image.getWidth())/(colTo-colFrom);
	int mX = colFrom;
	if(largeImageCol){
	    mX = colFrom + (int) (nowX/xStep);
	}else{
	    mX = colFrom + (int) (nowX/xStep) + 1;
	    if(nowX==0)
		mX = colFrom + (int) (nowX/xStep);
	}
	return getColumnGroup().getIObjectAt(mX);
    }
	
	



    protected IObjectGroup getColumnIObjects(int x){
	IObject startO = getClosestColumnIObject(x);
	IObject endO = getLastColumnIObject(x);
	//	IObject endO = getClosestColumnIObject(x+1);
	return getColumnGroup().subGroup(startO, endO);
    }

    protected IObjectGroup getRowIObjects(int y){
	IObject startO = getClosestRowIObject(y);
	IObject endO = getLastRowIObject(y);
	//	IObject endO = getClosestRowIObject(y+1);
	return getRowGroup().subGroup(startO, endO);
    }


    /**
     * Returns the closest x coordinate in the picture for a column
     * in the IMatrix. For columns that are larger than one pixel the
     * leftmost coordinate is returned.
     */
    protected int getClosestXPixelForColumn(int col){
	if(largeImageCol){
	    double xStep = ((double)image.getWidth())/(colTo-colFrom);
	    return (int) (col*xStep);
	}
	return (int) 
	    (((double) col)/(colTo-colFrom)*
	     (image.getWidth()-SparsePicture.getGridSize()));
	/*
	  return (int) 
	  Math.round(((double) col)/(colTo-colFrom)*
	  (image.getWidth()-SparsePicture.getGridSize()));
	*/
    }

    protected int getClosestYPixelForRow(int row){
	if(largeImageRow){
	    double yStep = ((double)image.getHeight())/(rowTo-rowFrom);
	    return (int) (row*yStep);
	}
	return (int) 
	    (((double) row)/(rowTo-rowFrom)*
	     (image.getHeight()-SparsePicture.getGridSize()));
	/*
	  return (int) 
	  Math.round(((double) row)/(rowTo-rowFrom)*
	  (image.getHeight()-SparsePicture.getGridSize()));
	*/
    }





    protected Vector<SparsePixel> getPixels(){
	return sparsePixels;
    }

    protected InfomatView getView(){
	return sparsePicture.getView();
    }


    /*
      protected IMatrix getIMatrix(){
      return matrix;
      }
    */
	
    protected int getIMatrixPartWidth(){
	return colTo-colFrom;
	//	return colWidth;
    }

    protected int getIMatrixPartHeight(){
	return rowTo-rowFrom;
	//	return rowHeight;
    }

    protected Dimension getIMatrixPartSize(){
	return new Dimension(getIMatrixPartWidth(), getIMatrixPartHeight());
    }

    protected int getImageWidth(){
	return imageDimension.width;
    }

    protected int getImageHeight(){
	return imageDimension.height;
    }

    protected int getOrigoX(){
	return origoX;
    }

    protected int getOrigoY(){
	return origoY;
    }

    protected int getGridX(){
	return gridX;
    }

    protected int getGridY(){
	return gridY;
    }

    protected int getOffsetX(){
	return offsetX;
    }

    protected int getOffsetY(){
	return offsetY;
    }

    protected Dimension getImageSize(){
	return imageDimension;
    }

    protected BufferedImage getImage(){
	return image;
    }

    protected Color getBackgroundColor(){
	return GroupingColoring.getBackgroundColor();
    }

    protected boolean toSmall(){
	return toSmall;
    }
	
	
    /**
     * Should not be run several times.
     *
     */
    protected void makeImage(){
	/*
	// The image only need to be constructed one time!
	if(image!=null)
	return;
	*/
		
	if(imageDimension.width<=0 || imageDimension.height <=0){
	    toSmall=true;
	    return;
	}
		
	image = new BufferedImage(imageDimension.width, imageDimension.height,
				  BufferedImage.TYPE_INT_RGB);
	Graphics2D g2 = image.createGraphics();
	g2.setBackground(getBackgroundColor());
	g2.setColor(getBackgroundColor());

	g2.fillRect(0,0,imageDimension.width,imageDimension.height);
	//	g2.fillRect(0,0,getSize().width,getSize().height);

	// Draw Column coloring
	//System.out.println("Draw Column coloring");
	//System.out.print("Weight: ");
	Vector<SparsePixel> columnColorPixels = 
	    new Vector<SparsePixel>(columnColorMap.values());
	if(columnColorPixels!=null){
	    for(int i=0; i<columnColorPixels.size(); i++){
		SparsePixel sp = columnColorPixels.elementAt(i);
		//System.out.print(sp+", "); //sp.getOpacity()+", ");
		Color color = 
		    sp.getColor(GroupingColoring.getBackgroundColor());
		if(color==Color.black)
		    color=GroupingColoring.getBackgroundColor();
		g2.setColor(color);
		int x = sp.getX();
		int y = sp.getY();

		/*
		if(getLargeImage())
		    g2.fillRect(x, y, xLast-x, imageDimension.height-y); //yLast-y);
		else
		    g2.drawLine(x, y, x, imageDimension.height-y);
		*/

		if(!getLargeImageRow() && !getLargeImageCol())
		    g2.drawLine(x, y, x, imageDimension.height-y);

		else{
		    int xLast= sp.getXLast();
		    //		    int yLast= sp.getYLast();
		    if(getLargeImageRow() && getLargeImageCol())
			g2.fillRect(x, y, xLast-x, imageDimension.height-y); //yLast-y);
		    else if(getLargeImageRow())
			g2.fillRect(x, y, x, imageDimension.height-y); //yLast-y);
		    else
			g2.fillRect(x, y, xLast-x, imageDimension.height-y); //yLast-y);
		}


	    }
	}
	//System.out.println();
		
	// Draw
	Vector<SparsePixel> pixels = getPixels();
	for(int i=0; i<pixels.size(); i++){
	    SparsePixel sp = (SparsePixel) pixels.elementAt(i);
	    Color color = 
		sp.getColor(GroupingColoring.getForgroundColor());
	    g2.setColor(color);
	    int x = sp.getX();
	    int y = sp.getY();

	    /*
	    if(getLargeImage()){
		int xLast= sp.getXLast();
		int yLast= sp.getYLast();
		g2.fillRect(x, y, xLast-x, yLast-y);
	    }else
		g2.drawLine(x, y, x, y);
	    */

	    if(!getLargeImageRow() && !getLargeImageCol())
		g2.drawLine(x, y, x, y);
	    else{
		int xLast= sp.getXLast();
		int yLast= sp.getYLast();
		if(getLargeImageRow() && getLargeImageCol())
		    g2.fillRect(x, y, xLast-x, yLast-y);
		else if(getLargeImageRow())
		    g2.drawLine(x, y, x, yLast-1);
		else if(getLargeImageCol())
		    g2.drawLine(x, y, xLast-1, y);
		else
		    g2.drawLine(x, y, x, y);
	    }

	}
	//System.out.println();

	g2.dispose();
    }

    protected void adjustColumnColorPixelsToHeight(){
	int height = getImageHeight();
	Vector<SparsePixel> columnColorPixels = 
	    new Vector<SparsePixel>(columnColorMap.values());
	for(int i=0; i<columnColorPixels.size(); i++){
	    columnColorPixels.elementAt(i).setYLast(height); //+columnColorPixels[i].getY());
	}
    }

    private void adjustOpacity(Vector<SparsePixel> vec, float newMinWeight, float newMaxWeight, 
			       float currentMinWeight, float currentMaxWeight){

	for(int i=0; i<vec.size(); i++){
	    SparsePixel sp = (SparsePixel) vec.elementAt(i);
	    //	    sp.makeAverageColor();
	    sp.linearScaleOpacity(newMinWeight, newMaxWeight, 
				  currentMinWeight, currentMaxWeight);
	}	
    }

    protected void adjustOpacity(float newMinWeight, float newMaxWeight, 
				 float currentMinWeight, float currentMaxWeight){
	adjustOpacity(sparsePixels, newMinWeight, newMaxWeight, currentMinWeight, currentMaxWeight);
    }

    protected void adjustColumnColorOpacity(float newMinWeight, float newMaxWeight, 
					    float currentMinWeight, float currentMaxWeight){
	Vector<SparsePixel> colorVector = 
	    new Vector<SparsePixel>(columnColorMap.values());
	adjustOpacity(colorVector, newMinWeight, newMaxWeight, currentMinWeight, currentMaxWeight);
    }

	


}
