package infomat.view.util;

import infomat.io.*;
import infomat.vectorspace.*;
import infomat.vectorspace.similarity.*;
import infomat.vectorspace.ivector.*;
import infomat.view.*;
import infomat.view.util.*;

import mro.util.*;
import mro.util.doublehashmap.DoubleHashMap;

import java.io.*;
import java.util.*;
import java.awt.Dimension;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;
import javax.swing.filechooser.FileFilter;

import org.xml.sax.SAXException;


public class ActionSelectionPanel 
    extends JPanel{

    private SmallButton apply;
    private JComboBox cBox;

    private String actionName;
    private Vector<String> actionNames = new Vector<String>();
    private String selected;

    private Font font;

    public ActionSelectionPanel(String actionName, 
				String[] actionNames,
				int init_selected, 
				Font font){
	this.actionName = actionName;
	this.font = font;
	apply = new SmallButton("Apply", font.getSize()); 
	
	
	for(int i=0; i<actionNames.length; i++)
	    this.actionNames.add(actionNames[i]);
	selected = actionNames[init_selected];

	setLayout(new BoxLayout(this, BoxLayout.X_AXIS));


	putAll();
    }

    public JButton getApplyButton(){
	return apply;
    }

    public String getAction(){
	return (String) cBox.getSelectedItem();
    }

    public void setButtonListener(ActionListener al){
	apply.addActionListener(al);
    }

    public void putAll(){
	removeAll();

	setLayout(new FlowLayout(FlowLayout.LEFT));
	JLabel label = new JLabel(actionName+": ");
	label.setFont(font);
	add(label);
	    
	cBox = new JComboBox(actionNames);
	cBox.setSelectedItem(selected);
	cBox.setFont(font);

	add(cBox);

	add(apply);

	revalidate();

	Dimension d = new Dimension((int) getPreferredSize().getWidth(), 
				    (int) getPreferredSize().getHeight());
	setPreferredSize(d);

	revalidate();
	repaint();
    }




    /*
    public boolean actionLeadToChange(){
	String newSelected = (String) cBox.getSelectedItem();
	System.out.println("newSelected: "+newSelected);
	if(selected != newSelected){
	    selected = newSelected;
	    return true;
	}
	return false;
    }
    */




}


