package infomat.view.util;

import infomat.io.*;
import infomat.vectorspace.ivector.*;
import infomat.view.*;
import infomat.view.util.*;

import mro.util.*;
import mro.util.doublehashmap.DoubleHashMap;

import java.io.*;
import java.util.*;
import java.awt.Dimension;

import java.awt.*;
import java.awt.event.*;
import java.net.*;

import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;
import javax.swing.filechooser.FileFilter;


/**
 * @version          080821
 * @author           Magnus Rosell
 */
public class FileViewer extends JFrame{
    public Dimension FILEVIEWER_PREFERRED_SIZE =
        new Dimension(600, 400);


    public FileViewer(String fileName){
        super("Object Viewer");

        setPreferredSize(FILEVIEWER_PREFERRED_SIZE);

        Container container = getContentPane();
        container.setPreferredSize(FILEVIEWER_PREFERRED_SIZE);
        container.setLayout(new BoxLayout(container, BoxLayout.Y_AXIS));

        /*
        if(!fileName.startsWith("file://") &&
           !fileName.startsWith("http://"))
            fileName = "file://"+fileName;
        */

        try {

            File file = new File(fileName);
            URL url = file.toURI().toURL();


            JPanel p = new JPanel();
            p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
            JLabel l = new JLabel(fileName);
            p.add(l);
            JScrollPane sp = new JScrollPane();
            sp.setViewportView(p);
            Dimension spd =
                new Dimension((int) FILEVIEWER_PREFERRED_SIZE.getWidth(),
                              (int) (3*p.getPreferredSize().getHeight()));
            sp.setPreferredSize(spd);
            sp.setMaximumSize(spd);
            sp.setMinimumSize(spd);

            container.add(sp);
            sp.setAlignmentX(LEFT_ALIGNMENT);

            JEditorPane htmlPane = new JEditorPane(url); //fileName);
            htmlPane.setEditable(false);
            JScrollPane htmlSP=new JScrollPane();
            htmlSP.setViewportView(htmlPane);
            container.add(htmlSP);
            htmlSP.setAlignmentX(LEFT_ALIGNMENT);



            setVisible(true);

            container.validate();
            validate();
            repaint();
            pack();


        } catch(MalformedURLException ioe) {
            System.err.println("Error displaying " + fileName);
            setVisible(false);
        } catch(IOException ioe) {
            System.err.println("Error displaying " + fileName);
            setVisible(false);
        }


    }

}




















/*
public class FileViewer extends JFrame{
    public Dimension FILEVIEWER_PREFERRED_SIZE = 
	new Dimension(600, 400);


    public FileViewer(String fileName){
	super("Object Viewer");

	setPreferredSize(FILEVIEWER_PREFERRED_SIZE);

	Container container = getContentPane();
	container.setPreferredSize(FILEVIEWER_PREFERRED_SIZE);
	container.setLayout(new BoxLayout(container, BoxLayout.Y_AXIS));


	if(!fileName.startsWith("file://") &&
	   !fileName.startsWith("http://"))
	    fileName = "file://"+fileName;

	try {

	    JPanel p = new JPanel();
	    p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
	    JLabel l = new JLabel(fileName);
	    p.add(l);
	    JScrollPane sp = new JScrollPane();
	    sp.setViewportView(p);
	    Dimension spd = 
		new Dimension((int) FILEVIEWER_PREFERRED_SIZE.getWidth(),
			      (int) (3*p.getPreferredSize().getHeight()));
	    sp.setPreferredSize(spd);
	    sp.setMaximumSize(spd);
	    sp.setMinimumSize(spd);

	    container.add(sp);
	    sp.setAlignmentX(LEFT_ALIGNMENT);

	    JEditorPane htmlPane = new JEditorPane(fileName);
	    htmlPane.setEditable(false);
	    JScrollPane htmlSP=new JScrollPane();
	    htmlSP.setViewportView(htmlPane);
	    container.add(htmlSP);
	    htmlSP.setAlignmentX(LEFT_ALIGNMENT);



	    setVisible(true);

	    container.validate();
	    validate();
	    repaint();
	    pack();


	} catch(IOException ioe) {
	    System.err.println("Error displaying " + fileName);
	    setVisible(false);
	}
	    

    }

}
*/
