package infomat.view.vector;

import infomat.io.*;
import infomat.vectorspace.*;
import infomat.vectorspace.ivector.*;
import infomat.view.*;
import infomat.view.util.*;

import mro.util.*;
import mro.util.doublehashmap.DoubleHashMap;

import java.io.*;
import java.util.*;
import java.awt.Dimension;

import java.awt.*;
import java.awt.event.*;
import java.net.*;

import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;
import javax.swing.filechooser.FileFilter;


/**
 * @version          080704
 * @author           Magnus Rosell
 */
public class IVectorIndexPanel<T extends IVectorIndex> 
    extends JPanel implements ActionListener{

    private int number;
    private T index;
    private float value;
    private boolean selectable;
    private InfomatModel model;
    //    private String browserName;

    private JCheckBox cb;
    private SmallButton locationB;

    private boolean showValue = true;

    private int smallestHeight=0;


    private static JTextField dummyTextField = new JTextField("Tg");
    private static int textFieldHeight = (int)
	(new JTextField("Tg")).getPreferredSize().getHeight();


    public IVectorIndexPanel(int number, 
			     T index, float value, 
			     boolean selectable, 
			     InfomatModel model){
	this.number=number;
	this.index=index;
	this.value=value;
	this.selectable=selectable;
	this.model=model;

	//	browserName = (String) model.getPropertyValue("Browser");

	putAll();
    }

    public void setShowValue(boolean showValue){
	this.showValue=showValue;
	putAll();
    }

    private void putAll(){
	removeAll();
	
	JPanel panel = new JPanel();
	setLayout(new FlowLayout(FlowLayout.LEFT));
	//	panel.setLayout(new FlowLayout(FlowLayout.LEFT));
	panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
	
	String str = number+". ";
	JLabel label = new JLabel(str);
	panel.add(label);

	Dimension panelDim = panel.getPreferredSize();
	int panelHeight = (int) panel.getPreferredSize().getHeight();

	if(index.getLocation()!=null && 
	   model!=null){ 
	    //	    && Desktop.isDesktopSupported()){
	    str = index.getString();
	    locationB = new SmallButton(str);
	    locationB.addActionListener(this);
	    panel.add(locationB);

	    //	    panelDim = locationB.getPreferredSize();
	    //	    panelHeight = (int) locationB.getPreferredSize().getHeight();
	    smallestHeight = textFieldHeight + 4;
	    //	    smallestHeight = (int) locationB.getPreferredSize().getHeight()+1;

	    if(showValue){
		str = ", "+value;
		label = new JLabel(str);
		panel.add(label);
	    }
	}else{
	    if(index instanceof IMatrixCell){
		IMatrixCell mc = (IMatrixCell) index;
		JPanel mcPanel = new JPanel();
		mcPanel.setBorder(new LineBorder(Color.BLACK));
		mcPanel.setLayout(new BoxLayout(mcPanel, BoxLayout.Y_AXIS));
		label = new JLabel("w: "+mc.getWeight());
		mcPanel.add(label);
		label = new JLabel("r: "+mc.getRowIObject().getString());
		mcPanel.add(label);
		label = new JLabel("c: "+mc.getColumnIObject().getString());
		mcPanel.add(label);

		panel.add(mcPanel);
		
		smallestHeight = 3*textFieldHeight - 2;
	    }else{
		str = index.getString();
		label = new JLabel(str);
		panel.add(label);
		
		//	    panelDim = label.getPreferredSize();
		//	    panelHeight = (int) label.getPreferredSize().getHeight();
		smallestHeight = textFieldHeight + 2;
		//	    smallestHeight = (int) dummyTextField.getPreferredSize().getHeight();

		if(showValue){
		    str = ", "+value;
		    label = new JLabel(str);
		    panel.add(label);
		}

	    }
	}

	
	if(selectable){
	    cb = new JCheckBox();
	    panel.add(cb);
	}else
	    cb = null;

	add(panel);
	/*
	panelDim = new Dimension((int) panel.getPreferredSize().getWidth(), panelHeight);
	setMaximumSize(panelDim);
	setMinimumSize(panelDim);
	*/

	revalidate();
	repaint();
    }

    public boolean isSelected(){
	if(cb!=null)
	    return cb.isSelected();
	return false;
    }

    public void setSelected(boolean b){
	if(cb!=null)
	    cb.setSelected(b);
    }

    public T getIVectorIndex(){
	return index;
    }

    public int getSmallestHeight(){
	return smallestHeight;
    }

    
    private static FileViewer fw;

    public void actionPerformed(ActionEvent e) {
	if(e.getSource() instanceof JButton){
	    JButton source = (JButton) e.getSource();
	    if(source == locationB){
		//		if(model!=null){
		    //		    System.out.println(index.getLocation());
		    //		    String command = browserName+" "+index.getLocation(); //+" &";
		    //		    runnableThread = new RunnableThread("hej", command); 

		    try{
			File f = new File(index.getLocation());
			fw = new FileViewer(f.getCanonicalPath());
		    }catch(IOException io){
			System.out.println("Unable to open viewer!");
			System.out.println();
		    }
		    /*
		    try{
			browserProcess = Runtime.getRuntime().exec(command);
		    }catch(IOException io){
			System.out.println("Unable to open browser!");
			io.printStackTrace(System.out);
			System.out.println();
			System.out.println("command: ");
			System.out.println(command);
		    }
		    */
		    //		}
	    }
	}
    }


  

}
