package mro.util.properties;

import java.io.*;
import java.util.*; 

/**
 *
 * @version          041207
 * @author           Magnus Rosell
 */

public class PropertyValueDescription{
    Object value;
    String valueDescription;

    public PropertyValueDescription(Object value, 
				    String valueDescription){
	this.value=value;
	this.valueDescription=valueDescription;
    }

    public PropertyValueDescription(boolean value, 
				    String valueDescription){
	this(new Boolean(value), valueDescription);
    }

    public PropertyValueDescription(int value, 
				    String valueDescription){
	this(new Integer(value), valueDescription);
    }

    public Object getValue(){
    	return value;
    }
    
    public String getValueDescription(){
    	return valueDescription;
    }
    
    public void printXML(PrintWriter pw) throws IOException{
	pw.println("<pvd><v>"+value+"</v><d>"+valueDescription+"</d></pvd>");
    }

    
    
}

